﻿
namespace flowerpot.Web
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Data;
    using System.Linq;
    using System.ServiceModel.DomainServices.EntityFramework;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;



    // Implements application logic using the flowerpotEntities context.
    // TODO: Add your application logic to these methods or in additional methods.
    // TODO: Wire up authentication (Windows/ASP.NET Forms) and uncomment the following to disable anonymous access
    // Also consider adding roles to restrict access as appropriate.
    // [RequiresAuthentication]
    [EnableClientAccess()]
    public class flowerpotDomainService : LinqToEntitiesDomainService<flowerpotEntities>
    {

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Actualizacion' query.
        public IQueryable<Actualizacion> GetActualizacion()
        {
            return this.ObjectContext.Actualizacion;
        }

        public IQueryable<Actualizacion> GetActualizacionEjemplar(int idEjemplar)
        {
            return ObjectContext.Actualizacion.Where(so => so.IdEjemplar == idEjemplar);
        }

        public void InsertActualizacion(Actualizacion actualizacion)
        {
            if ((actualizacion.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(actualizacion, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Actualizacion.AddObject(actualizacion);
            }
        }

        public void UpdateActualizacion(Actualizacion currentActualizacion)
        {
            this.ObjectContext.Actualizacion.AttachAsModified(currentActualizacion, this.ChangeSet.GetOriginal(currentActualizacion));
        }

        public void DeleteActualizacion(Actualizacion actualizacion)
        {
            if ((actualizacion.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Actualizacion.Attach(actualizacion);
            }
            this.ObjectContext.Actualizacion.DeleteObject(actualizacion);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Comentarios' query.
        public IQueryable<Comentarios> GetComentarios()
        {
            return this.ObjectContext.Comentarios;
        }

        public IQueryable<Comentarios> GetComentarioEjemplar(int idEjemplar)
        {
            return ObjectContext.Comentarios.Where(so => so.IdEjemplar == idEjemplar);
        }
        

        public void InsertComentarios(Comentarios comentarios)
        {
            if ((comentarios.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(comentarios, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Comentarios.AddObject(comentarios);
            }
        }

        public void UpdateComentarios(Comentarios currentComentarios)
        {
            this.ObjectContext.Comentarios.AttachAsModified(currentComentarios, this.ChangeSet.GetOriginal(currentComentarios));
        }

        public void DeleteComentarios(Comentarios comentarios)
        {
            if ((comentarios.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Comentarios.Attach(comentarios);
            }
            this.ObjectContext.Comentarios.DeleteObject(comentarios);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Ejemplar' query.


        public IQueryable<Ejemplar> GetEjemplar()
        {
            return this.ObjectContext.Ejemplar;
        }

        public IQueryable<Ejemplar> GetEjemplarEspecie(int idEspecie)
        {
            return ObjectContext.Ejemplar.Where(so => so.IdEspecie == idEspecie);
        }

        public IQueryable<Ejemplar> GetEjemplarUsuario(int idUsuario)
        {
            return ObjectContext.Ejemplar.Where(so => so.IdUsuario == idUsuario);
        }

        public void InsertEjemplar(Ejemplar ejemplar)
        {
            if ((ejemplar.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(ejemplar, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Ejemplar.AddObject(ejemplar);
            }
        }

        public void UpdateEjemplar(Ejemplar currentEjemplar)
        {
            this.ObjectContext.Ejemplar.AttachAsModified(currentEjemplar, this.ChangeSet.GetOriginal(currentEjemplar));
        }

        public void DeleteEjemplar(Ejemplar ejemplar)
        {
            if ((ejemplar.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Ejemplar.Attach(ejemplar);
            }
            this.ObjectContext.Ejemplar.DeleteObject(ejemplar);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Especie' query.

        public IQueryable<Especie> GetEspecie()
        {
            return this.ObjectContext.Especie;

        }


        public void InsertEspecie(Especie especie)
        {
            if ((especie.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(especie, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Especie.AddObject(especie);
            }
        }

        public void UpdateEspecie(Especie currentEspecie)
        {
            this.ObjectContext.Especie.AttachAsModified(currentEspecie, this.ChangeSet.GetOriginal(currentEspecie));
        }

        public void DeleteEspecie(Especie especie)
        {
            if ((especie.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Especie.Attach(especie);
            }
            this.ObjectContext.Especie.DeleteObject(especie);
        }

 
        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Usuario' query.
        public IQueryable<Usuario> GetUsuario()
        {
            return this.ObjectContext.Usuario;
        }

        public IQueryable<Usuario> GetLogin(string Nombre, string Password)
        {
            return this.ObjectContext.Usuario.Where(so => so.Name == Nombre & so.Password == Password);
        }

        public IQueryable<Usuario> GetUsuarioId(int idUsuario)
        {
            return ObjectContext.Usuario.Where(so => so.Id == idUsuario);
        }

        [Invoke]
        //Custom Validation for Async Operation
        public bool IsUserExist(string userName)
        {
            bool IsUserExist = false;

            IsUserExist = GetUsuario().Any(user => user.Name == userName);


            return IsUserExist;
        }

        public void InsertUsuario(Usuario usuario)
        {
            if ((usuario.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(usuario, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Usuario.AddObject(usuario);
            }
        }

        public void UpdateUsuario(Usuario currentUsuario)
        {
            this.ObjectContext.Usuario.AttachAsModified(currentUsuario, this.ChangeSet.GetOriginal(currentUsuario));
        }

        public void DeleteUsuario(Usuario usuario)
        {
            if ((usuario.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Usuario.Attach(usuario);
            }
            this.ObjectContext.Usuario.DeleteObject(usuario);
        }
    }
}


