﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Navigation;
using flowerpot.Web;
using System.ServiceModel.DomainServices.Client;
using System.Windows.Media.Imaging;

namespace flowerpot.Views
{
    public partial class ComentariosView : Page
    {
        flowerpotDomainContext _Context = new flowerpotDomainContext();
        public ComentariosView()
        {
            InitializeComponent();
            btnAdd.Visibility = Autenticado.Registrado ? System.Windows.Visibility.Visible : System.Windows.Visibility.Collapsed;
            btnEdit.Visibility = Autenticado.Propietario | Autenticado.Administrador ? System.Windows.Visibility.Visible : System.Windows.Visibility.Collapsed;
            btnDel.Visibility = Autenticado.Propietario | Autenticado.Administrador ? System.Windows.Visibility.Visible : System.Windows.Visibility.Collapsed;
        }

        // Executes when the user navigates to this page.
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            LoadData();
        }

        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            //Create a New Comentario Object
            Comentarios comenObject = new Comentarios();
            comenObject.Fecha = DateTime.Now;
            int ejID = int.Parse(this.NavigationContext.QueryString["ejID"]);
            comenObject.IdEjemplar = ejID;
            comenObject.IdUsuario = Autenticado.IdUsuario;

            //Add to the Collection of Domain DataContext
            _Context.Comentarios.Add(comenObject);

            //Create a PopUp Child Window Object
            Views.AddComentario chldWind = new Views.AddComentario();

            chldWind.Title = "Añadir Comentario";

            //Getting the GridLayout Control of the popUp To Be Shown and assign the Newly Created Object
            ((Grid)chldWind.FindName("chldMainContainer")).DataContext = comenObject;


            //Attach The Todo on Close Event handaler
            chldWind.Closed += new EventHandler(chldWind_Closed);


            chldWind.Show();
        }

        void chldWind_Closed(object sender, EventArgs e)
        {
            ChildWindow chldWind = (ChildWindow)sender;
            if ((chldWind.DialogResult == true))
            {
                SubmitOperation so;
                try
                {

                    so = _Context.SubmitChanges(OnSubmitCompleted, null);
                }
                catch (Exception exp)
                {

                    MessageBox.Show(exp.Message);
                }
            }
            else
            {
                _Context.RejectChanges();
            }
        }

        /// <summary>
        /// CallBack Function for SubmitChanges
        /// </summary>
        /// <param name="so"></param>
        private void OnSubmitCompleted(SubmitOperation so)
        {
            if (so.HasError)
            {
                MessageBox.Show(string.Format("Submit Failed: {0}", so.Error.Message));
                so.MarkErrorAsHandled();
            }

            LoadData();
        }


        private void LoadData()
        {
            if (this.NavigationContext.QueryString.ContainsKey("ejID"))
            {
                int ejID = int.Parse(this.NavigationContext.QueryString["ejID"]);
                _Context.Load(_Context.GetComentarioEjemplarQuery(ejID));
            }
            else
            {
                _Context.Load(_Context.GetComentariosQuery());
            }
            comentarioDataGrid.ItemsSource = _Context.Comentarios;
        }

        private void btnEdit_Click(object sender, RoutedEventArgs e)
        {
            
            if (comentarioDataGrid.SelectedItem == null)
            {
                MessageBox.Show("Seleccione un Comentario de la lista.");
                return;
            }
            //Creating a new object of Popup
            AddComentario chldWind = new AddComentario();

            chldWind.Title = "Editar Comentario";

            //Getting the GridLayout Control of the popUp To Be Shown and assign the Selected Item
            ((Grid)chldWind.FindName("chldMainContainer")).DataContext = comentarioDataGrid.SelectedItem;


            //Add a Event Handaler Which will Execute the Submit The Changes  made to entity Assigned
            chldWind.Closed += new EventHandler(chldWind_Closed);

            chldWind.Show();
        }

        private void btnDel_Click(object sender, RoutedEventArgs e)
        {
            if (comentarioDataGrid.SelectedItem == null)
            {
                MessageBox.Show("Seleccione un Comentario de la lista.");
                return;
            }

            Comentarios selectedComen = (Comentarios)comentarioDataGrid.SelectedItem;
            if (MessageBox.Show("¿Está seguro que desea borrar el comentario seleccionado?",
                "Confirmación", MessageBoxButton.OKCancel) == MessageBoxResult.OK)
            {
                _Context.Comentarios.Remove(selectedComen);
                _Context.SubmitChanges(OnSubmitCompleted, null);

            }
        }

            
        


    }
}

