﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Navigation;
using flowerpot.Web;
using System.ServiceModel.DomainServices.Client;


namespace flowerpot.Views
{
    public partial class EspeciesView : Page
    {
        flowerpotDomainContext _Context = new flowerpotDomainContext();

        public EspeciesView()
        {
            InitializeComponent();

            btnAdd.Visibility = Autenticado.Registrado ? System.Windows.Visibility.Visible : System.Windows.Visibility.Collapsed;
            btnEdit.Visibility = Autenticado.Registrado ? System.Windows.Visibility.Visible : System.Windows.Visibility.Collapsed;
            btnDel.Visibility = Autenticado.Registrado ? System.Windows.Visibility.Visible : System.Windows.Visibility.Collapsed;          
        }

        // Executes when the user navigates to this page.
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            LoadData();        
        }


        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            //Create a New Especie Object
            Especie especieObject = new Especie();

            //Add to the Collection of Domain DataContext
            _Context.Especies.Add(especieObject);

            //Create a PopUp Child Window Object
            Views.AddNewEspecie chldWind = new Views.AddNewEspecie();

            chldWind.Title = "Añadir Especie";

            //Getting the GridLayout Control of the popUp To Be Shown and assign the Newly Created Object
            ((Grid)chldWind.FindName("chldMainContainer")).DataContext = especieObject;
            

            //Attach The Todo on Close Event handaler
            chldWind.Closed += new EventHandler(chldWind_Closed);


            chldWind.Show();
        }

        void chldWind_Closed(object sender, EventArgs e)
        {
            ChildWindow chldWind = (ChildWindow)sender;
            if ((chldWind.DialogResult == true))
            {
                SubmitOperation so;
                try
                {

                    so = _Context.SubmitChanges(OnSubmitCompleted, null);
                }
                catch (Exception exp)
                {

                    MessageBox.Show(exp.Message);
                }
            }
            else
            {
                _Context.RejectChanges();
            }
        }

        /// <summary>
        /// CallBack Function for SubmitChanges
        /// </summary>
        /// <param name="so"></param>
        private void OnSubmitCompleted(SubmitOperation so)
        {
            if (so.HasError)
            {
                MessageBox.Show(string.Format("Submit Failed: {0}", so.Error.Message));
                so.MarkErrorAsHandled();
            }

            LoadData();
        }


        private void LoadData()
        {
            _Context.Load(_Context.GetEspecieQuery());
            especieDataGrid.ItemsSource = _Context.Especies;

        }

        private void btnEdit_Click(object sender, RoutedEventArgs e)
        {
            if (especieDataGrid.SelectedItem == null)
            {
                MessageBox.Show("Seleccione una especie de la lista.");
                return;
            }
            //Creating a new object of Popup
            AddNewEspecie chldWind = new AddNewEspecie();

            chldWind.Title = "Editar Especie";

            //Getting the GridLayout Control of the popUp To Be Shown and assign the Selected Item
            ((Grid)chldWind.FindName("chldMainContainer")).DataContext = especieDataGrid.SelectedItem;
           

            //Add a Event Handaler Which will Execute the Submit The Changes  made to entity Assigned
            chldWind.Closed += new EventHandler(chldWind_Closed);

            chldWind.Show();
        }

        private void btnDel_Click(object sender, RoutedEventArgs e)
        {
            if (especieDataGrid.SelectedItem == null)
            {
                MessageBox.Show("Seleccione una especie de la lista.");
                return;
            }

            Especie selectedEspecie = (Especie)especieDataGrid.SelectedItem;

            if (MessageBox.Show("Está seguro que desea borrar la Especie " + selectedEspecie.Nombre +
                "?", "Confirmación", MessageBoxButton.OKCancel) == MessageBoxResult.OK)
            {
                _Context.Especies.Remove(selectedEspecie);
                _Context.SubmitChanges(OnSubmitCompleted, null);

            }
        }

    }
}
