﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using flowerpot.Web;
using System.ServiceModel.DomainServices.Client;

namespace flowerpot.Views
{
    public partial class Login : ChildWindow
    {
        public Login()
        {
            InitializeComponent();     
        }

        private void OKButton_Click(object sender, RoutedEventArgs e)
        {
            flowerpotDomainContext _Context = new flowerpotDomainContext();

            EntityQuery<Usuario> query = from c in _Context.GetLoginQuery(txtUserName.Text, txtPassword.Password) select c;
            LoadOperation<Usuario> lop = _Context.Load(query);

            lop.Completed += ((Authsender, args) =>
            {
                if (lop.HasError)
                    MessageBox.Show(lop.Error.Message);

                else
                {
                    if (_Context.Usuarios.Count == 1)
                    {
                        Usuario usu = _Context.Usuarios.First();
                        Autenticado.Usuario = usu.Name;
                        Autenticado.IdUsuario = usu.Id;
                        Autenticado.Registrado = true;
                        Autenticado.Administrador = usu.Administrador;
                        this.DialogResult = true;
                    }
                    else
                    {
                        lblAuthStatus.Content = "Login Erroneo";
                    }
                }

            });         
        }

        private void CancelButton_Click(object sender, RoutedEventArgs e)
        {
            this.DialogResult = false;
        }

        private void ChildWindow_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Enter)
            {
                OKButton_Click(sender, new RoutedEventArgs());
            }
            else if (e.Key == Key.Escape)
            {
                CancelButton_Click(sender, new RoutedEventArgs());
            }
            else
            {
                lblAuthStatus.Content = "";
            }
        }
    }
}

